love.mouse.setVisible( false )

frikandels = {}
dogfoods = {}
fishfoods = {}
  
 -- Taken from https://love2d.org/wiki/BoundingBox.lua 
function CheckCollision(x1,y1,w1,h1, x2,y2,w2,h2)
  return x1 < x2+w2 and
         x2 < x1+w1 and
         y1 < y2+h2 and
         y2 < y1+h1
end

function love.load()
  gamestate = "intro"
  
  -- Something the internet said would help
  -- no idea what I am doing here
  math.randomseed( os.time() )
  math.random(); math.random(); math.random()
  
  -- images
  img_seppe = love.graphics.newImage("img/seppe.png")
  img_seppegroot = love.graphics.newImage("img/seppegroot.png")    
  img_fishfood = love.graphics.newImage("img/vis.png")  
  img_fish = love.graphics.newImage("img/visgroot.png")  
  img_dogfood = love.graphics.newImage("img/dogfood.png")  
  img_frikandel = love.graphics.newImage("img/frikandel.png")  
  img_intro = love.graphics.newImage("img/intro.png")  
  img_fatend = love.graphics.newImage("img/gameoverfat.png")  
  img_fishend = love.graphics.newImage("img/gameoverfish.png")  
 
  -- timer
  timerInit = 1.0
  timer1 = timerInit
  timer2 = timerInit
  timer3 = timerInit

  -- seppe
  seppe = {}
  seppe.x = love.window.getWidth()/2 - img_seppe:getWidth()/2
  seppe.y = love.window.getHeight() - img_seppe:getHeight() - 10
  
  seppeFish = 0
  seppeFat = 0
  seppeFull = 0
  

end

function love.draw()
  if gamestate == "intro" then
    love.graphics.draw(img_intro, love.window.getWidth()/2 - img_intro:getWidth()/2, love.window.getHeight()/2 - img_intro:getHeight()/2)
  end
  
  if gamestate == "game" then
  
  -- SEPPE
  love.graphics.draw(img_seppe, seppe.x, seppe.y)  
  
  -- FOODSTUFF
  for i,v in ipairs(frikandels) do 
    love.graphics.draw(img_frikandel, v.x, v.y)
  end
  for i,v in ipairs(dogfoods) do 
    love.graphics.draw(img_dogfood, v.x, v.y)
  end
  for i,v in ipairs(fishfoods) do 
    love.graphics.draw(img_fishfood, v.x, v.y)
  end
  
  -- scores
  if gamestate == "gameover" or gamestate == "game" then
    love.graphics.line(0, 50, love.window.getWidth(), 50)
    love.graphics.draw(img_fishfood, 25, 45 - img_fishfood:getHeight())
    love.graphics.draw(img_dogfood, love.window.getWidth()/3, 45 - img_dogfood:getHeight())
    love.graphics.draw(img_frikandel, (love.window.getWidth()/3)*2, 45 - img_frikandel:getHeight())
    love.graphics.print(seppeFish, 25 + img_fishfood:getWidth(), 25)
    love.graphics.print(seppeFull, love.window.getWidth()/3 + img_dogfood:getWidth() + 5, 25)
    love.graphics.print(seppeFat, (love.window.getWidth()/3)*2 + img_frikandel:getWidth() + 5, 25)
  end
 end

  -- losing
  if gamestate == "gameover" then
  if seppeFish > 15 then
    love.graphics.draw(img_fishend, love.window.getWidth()/2 - img_fishend:getWidth()/2, love.window.getHeight()/2 - img_fishend:getHeight()/2)
  else
    love.graphics.draw(img_fatend, love.window.getWidth()/2 - img_fatend:getWidth()/2, love.window.getHeight()/2 - img_fatend:getHeight()/2)
  end
 end
end

function love.update(dt)

  if gamestate == "game" then
  
   -- UPDATING
  timer1 = timer1 - (1 * dt)
  timer2 = timer2 - (0.5 * dt)
  timer3 = timer3 - (1.5 * dt)

  if timer1 < 0 then
    timer1 = math.random(3)
	frikandel = {x = math.random(10, love.window.getWidth() - 50), y = 35}     
	table.insert(frikandels, frikandel)
  end
  
  if timer2 < 0 then
    timer2 = math.random(3)
    dogfood = {x =  math.random(10, love.window.getWidth() - 10), y = 35}	
	table.insert(dogfoods, dogfood)
  end
  
  if timer3 < 0 then
    timer3 = math.random(3)
	fishfood = {x =  math.random(10, love.window.getWidth() - 10), y = 35}
    table.insert(fishfoods, fishfood)
  end
  
  -- FALLING
  for i,v in ipairs(frikandels) do 
  if v.y < seppe.y then
      v.y = v.y + 150 * dt 
    else
      table.remove(frikandels,i)
    end  
  end

  for i,v in ipairs(dogfoods) do 
    if v.y < seppe.y then
      v.y = v.y + 150 * dt 
    else
      table.remove(dogfoods,i)
    end
  end
  
  for i,v in ipairs(fishfoods) do 
    if v.y < seppe.y then
	  v.y = v.y + 150 * dt 	  
	else
      table.remove(fishfoods,i)
	end
  end
  
  -- POINTS
  
   for i,fishfood in ipairs(fishfoods) do 
     if CheckCollision(fishfood.x, fishfood.y, img_fishfood:getWidth(),
	 img_fishfood:getHeight(), seppe.x, seppe.y,
	 img_seppe:getWidth(), img_seppe:getHeight()) then
	   seppeFish = seppeFish + 1 	  
	   table.remove(fishfoods,i)
     end
   end
   
   for i,dogfood in ipairs(dogfoods) do 
     if CheckCollision(dogfood.x, dogfood.y, img_dogfood:getWidth(),
	 img_dogfood:getHeight(), seppe.x, seppe.y,
	 img_seppe:getWidth(), img_seppe:getHeight()) then
	   seppeFull = seppeFull + 1 	  
	   table.remove(dogfoods,i)
     end
   end
   
   for i,frikandel in ipairs(frikandels) do 
     if CheckCollision(frikandel.x, frikandel.y, img_frikandel:getWidth(),
	 img_frikandel:getHeight(), seppe.x, seppe.y,
	 img_seppe:getWidth(), img_seppe:getHeight()) then
	   seppeFat = seppeFat + 1 	  
	   table.remove(frikandels,i)
     end
   end
  
  -- MOVING
  if love.keyboard.isDown("a") or love.keyboard.isDown("left") then
    if  seppe.x > 0 then
    seppe.x = seppe.x - 400*dt	  
	end
  elseif love.keyboard.isDown("d") or love.keyboard.isDown("right") then
    if seppe.x < love.window.getWidth() - img_seppe:getWidth() then
    seppe.x = seppe.x + 400*dt	 
	end
  end 
 
 -- Game over
  if seppeFish > 15 then
    gamestate = "gameover"
  end
 
  if seppeFat > 15 then
   gamestate = "gameover"
  end
  end 

 end 
 

 -- start game
function love.keypressed(key)
  if gamestate == "intro" and key == "return" then
     gamestate = "game"
 end
end
 
  
